import "Turbine.UI"; -- this will expose the label control that we will implement
import "Turbine.UI.Lotro"; -- this will expose the standard window that we will implement
import "Turbine.Gameplay";

----stealth text
----benefit with Camouflage
--benefit with Sneak
--benefit with Hobbit-stealth
--Hide in Plain Sight
--Silvan Shadows
--Careful Step
--Tarnung
--Vorsichtiger Schritt
--Silvanische Schatten
--Heimlichkeit
--In Luft auflsen
--Schleichen

tickDelay=10

dc=Turbine.ShellCommand()
beenFound= function(name)

	CountdownWindow:SetPosition(Turbine.UI.Display:GetWidth()/2-250,Turbine.UI.Display:GetHeight()/2-300)
	CountdownWindow:SetSize(500,200)
	TimeMessage:SetPosition(0,50)
	Title:SetPosition(0,0)

	CountdownWindow:SetBackColor(Turbine.UI.Color(0.2,0,0,0))
	startTime=Turbine.Engine.GetLocalTime()
	TimeMessage:SetText("")
	Title:SetText(name.." Has Been Found!")
	CountdownWindow:SetVisible(true)
	CountdownWindow:SetWantsUpdates(true)
end

beenQuit= function(name)
	if playing == true then
		CountdownWindow:SetPosition(Turbine.UI.Display:GetWidth()/2-250,Turbine.UI.Display:GetHeight()/2-300)
		CountdownWindow:SetSize(500,200)
	
		TimeMessage:SetPosition(0,50)
		Title:SetPosition(0,0)

		CountdownWindow:SetBackColor(Turbine.UI.Color(0.2,0,0,0))
		startTime=Turbine.Engine.GetLocalTime()
		TimeMessage:SetText("")
	end
	Title:SetText(name.." Has Quit the Game!")
	CountdownWindow:SetVisible(true)
	CountdownWindow:SetWantsUpdates(true)
end


gameOver = function(name)
	startTime=Turbine.Engine.GetLocalTime()

	CountdownWindow:SetPosition(Turbine.UI.Display:GetWidth()/2-250,Turbine.UI.Display:GetHeight()/2-300)
	CountdownWindow:SetSize(500,200)
	TimeMessage:SetPosition(0,50)
	Title:SetPosition(0,0)

	CountdownWindow:SetBackColor(Turbine.UI.Color(0.2,0,0,0))

	TimeMessage:SetText("")
	Title:SetText(name.." Has Won!")
	playing=nil
	queueingPlayers={[playerName]={["Code"]=playerNo}}
	currentPlayers=nil
	CountdownWindow:SetVisible(true)
	CountdownWindow:SetWantsUpdates(true)

end


	


function startGame()
	seed=math.random(1000)
	if currentGameCode== nil or currentGameCode =="nil" then
		currentGameCode=gameNo
	end

	playing = false
	MainWindow:SetVisible(false)
	currentPlayers=queueingPlayers
	updateLists()
	if currentPlayers[playerName]["Seeker"] == true then

		targetopacity=1
		CountdownWindow:SetBackColor(Turbine.UI.Color(1,0,0,0))
		CountdownWindow:SetPosition(0,0)
		CountdownWindow:SetSize(Turbine.UI.Display:GetWidth(),Turbine.UI.Display:GetHeight())

		TimeMessage:SetPosition(Turbine.UI.Display:GetWidth()/2-250,Turbine.UI.Display:GetHeight()/2-350)
		Title:SetPosition(Turbine.UI.Display:GetWidth()/2-250,Turbine.UI.Display:GetHeight()/2-400)

		Title:SetText("Seeking")
	else
		Title:SetText("Hide!")
		targetopacity=0.2
		CountdownWindow:SetPosition(Turbine.UI.Display:GetWidth()/2-250,Turbine.UI.Display:GetHeight()/2-300)
		CountdownWindow:SetSize(500,200)
		TimeMessage:SetPosition(0,50)
		Title:SetPosition(0,0)

		CountdownWindow:SetBackColor(Turbine.UI.Color(0.2,0,0,0))
	end
	opacity=0
	CountdownWindow:SetVisible(true)
	startTime=Turbine.Engine.GetLocalTime()
	oldTime=Turbine.Engine.GetLocalTime()
	CountdownWindow:SetWantsUpdates(true)
	TimeMessage:SetText(tostring(countIn))


end




CountdownWindow=Turbine.UI.Window()
CountdownWindow:SetWantsUpdates(false)
CountdownWindow:SetMouseVisible(false)

Title=Turbine.UI.Label()
Title:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
Title:SetParent(CountdownWindow)
Title:SetSize(500,100)
Title:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)

TimeMessage=Turbine.UI.Label()
TimeMessage:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
TimeMessage:SetParent(CountdownWindow)
TimeMessage:SetSize(500,200)
TimeMessage:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)

ListWindow =Turbine.UI.Lotro.Window()
ListWindow:SetWantsUpdates(false)
ListWindow:SetVisible(false)
ListWindow:SetText("Players")


ListWindow:SetPosition(30,30)
ListWindow:SetSize(500,300)
ListCont=Turbine.UI.ListBox()
ListCont:SetParent(ListWindow)
ListCont:SetSize(400,200)
ListCont:SetPosition(50,50)
ListCont:SetOrientation(Turbine.UI.Orientation.Horizontal)

ListLeft=Turbine.UI.ListBox()
ListLeft:SetSize(190,200)
ListLeft:SetOrientation(Turbine.UI.Orientation.Vertical)
ListCont:AddItem(ListLeft)
SBLeft=Turbine.UI.Lotro.ScrollBar()
SBLeft:SetSize(10,200)
SBLeft:SetOrientation(Turbine.UI.Orientation.Vertical)

ListCont:AddItem(SBLeft)

ListRight=Turbine.UI.ListBox()
ListRight:SetSize(190,200)
ListRight:SetOrientation(Turbine.UI.Orientation.Vertical)
ListCont:AddItem(ListRight)
SBRight=Turbine.UI.Lotro.ScrollBar()
SBRight:SetSize(10,200)
SBRight:SetOrientation(Turbine.UI.Orientation.Vertical)




ListCont:AddItem(SBRight)

SBRight.ValueChanged=function()
	updateLists()
end

SBLeft.ValueChanged=function()
	updateLists()
end


updateLists=function()
	ListWindow:SetVisible(true)
	ListLeft:ClearItems()

	ListRight:ClearItems()
	if currentPlayers ~= nil then
		local count=1
		local text = Turbine.UI.Label()
		text:SetMarkupEnabled(true)
		text:SetText("<u>Seekers</u>")
		text:SetSize(190,22)
		ListRight:AddItem(text)
		for i in pairs(currentPlayers) do
			if currentPlayers[i]["Seeker"] == true and count >= SBRight:GetValue() then
				local text = Turbine.UI.Label()
				text:SetText(i)
				text:SetSize(190,22)
				ListRight:AddItem(text)
			count=count+1
			end
		end
		SBRight:SetMaximum(count)

		local count=1
		local text = Turbine.UI.Label()
		text:SetMarkupEnabled(true)
		text:SetText("<u>Hiders</u>")
		text:SetSize(190,22)
		ListLeft:AddItem(text)
		for i in pairs(currentPlayers) do
			if currentPlayers[i]["Seeker"] == false and count >= SBLeft:GetValue() then
				local text = Turbine.UI.Label()
				text:SetText(i)
				text:SetSize(190,22)
				ListLeft:AddItem(text)
			count=count+1
			end
		end
		SBLeft:SetMaximum(count)

	else

		local count=1
		local text = Turbine.UI.Label()
		text:SetMarkupEnabled(true)
		text:SetText("<u>Seekers</u>\nTBD")
		text:SetSize(190,44)
		ListRight:AddItem(text)
		SBRight:SetMaximum(count)

		local count=1
		local text = Turbine.UI.Label()
		text:SetMarkupEnabled(true)
		text:SetText("<u>Hiders</u>")
		text:SetSize(190,22)
		ListLeft:AddItem(text)
		for i in pairs(queueingPlayers)do
			if count >= SBLeft:GetValue() then
				local text = Turbine.UI.Label()
				text:SetText(i)
				text:SetSize(190,22)
				ListLeft:AddItem(text)
			count=count+1
			end
		end
		SBLeft:SetMaximum(count)

	end
end


	


CountdownWindow.Update = function()
	if playing == false then
		if Turbine.Engine.GetLocalTime()-startTime < countIn-4  and opacity < targetopacity then
			opacity = opacity+0.01
			CountdownWindow:SetBackColor(Turbine.UI.Color(opacity,0,0,0))
		end
	
	
		if Turbine.Engine.GetLocalTime() - oldTime > 0.9 then
			TimeMessage:SetText("Game Begins in: "..tostring(math.floor(countIn-(Turbine.Engine.GetLocalTime()-startTime))))
			oldTime=Turbine.Engine.GetLocalTime()
		end
		if Turbine.Engine.GetLocalTime()-startTime > countIn-4 and opacity > 0 then
			opacity = opacity-0.01
			CountdownWindow:SetBackColor(Turbine.UI.Color(opacity,0,0,0))
		end

		if Turbine.Engine.GetLocalTime()-startTime > countIn then
			CountdownWindow:SetVisible(false)
			CountdownWindow:SetWantsUpdates(false)
			playing=true
		end
	elseif Turbine.Engine.GetLocalTime()-startTime > 10 and playing == true then
		CountdownWindow:SetVisible(false)
		CountdownWindow:SetWantsUpdates(false)
	elseif Turbine.Engine.GetLocalTime()-startTime > 10 and playing == nil then
		CountdownWindow:SetVisible(false)
		CountdownWindow:SetWantsUpdates(false)
		MainWindow:SetVisible(true)
		ListWindow:SetVisible(false)


	end
	
		
end




































print=Turbine.Shell.WriteLine
function dc:Execute(cmd, args)
	if currentPlayers == nil then
		MainWindow:SetVisible(true)
	else
		ListWindow:SetVisible(true)
		updateLists()
	end		
end
player=Turbine.Gameplay.LocalPlayer.GetInstance()

-----------------------------------------------------------------------------found window-------------------------------------------------

FoundWindow =Turbine.UI.Window()
FoundWindow:SetWantsUpdates(false)
FoundWindow:SetVisible(false)
FoundWindow:SetText("Found")
FoundWindow:SetPosition(Turbine.UI.Display:GetWidth()/2-52,Turbine.UI.Display:GetHeight()/2-300)
FoundWindow:SetSize(104,104)
--FoundWindow:SetBackColor(Turbine.UI.Color(1,0,0,0))

FoundWindow.FoundButton=Turbine.UI.Lotro.Quickslot();
FoundWindow.FoundButton:SetParent(FoundWindow);
FoundWindow.FoundButton:SetSize(64,64);

FoundWindow.FoundButton:SetPosition(20,20); --yeah, I got lazy and hardcoded the left side ;)
FoundWindow.FoundButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,""))
FoundWindow.FoundButton.ShortcutData=""; --save the alias text for later
FoundWindow.FoundButton:SetAllowDrop(false); -- turn off drag and drop so the user doesn't accidentally modify our button action
FoundWindow.FoundButton.DragDrop=function()
    -- even though we turned off drop operations, there is a bug that allows the quickslot to drop on itself effectively wiping out the shortcut
    local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"");
    sc:SetData(FoundWindow.FoundButton.ShortcutData);
    FoundWindow.FoundButton:SetShortcut(sc);
end
FoundWindow.FoundButton.Icon=Turbine.UI.Control();
FoundWindow.FoundButton.Icon:SetParent(FoundWindow);
FoundWindow.FoundButton.Icon:SetSize(FoundWindow.FoundButton:GetSize());
FoundWindow.FoundButton.Icon:SetPosition(FoundWindow.FoundButton:GetPosition()); --yeah, I got lazy and hardcoded the left side ;)
FoundWindow.FoundButton.Icon:SetZOrder(FoundWindow.FoundButton:GetZOrder()+5); -- force the icon to be displayed above the quickslot
FoundWindow.FoundButton.Icon:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the quickslot behind it
--FoundWindow.FoundButton.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay); -- this will cause any transparent parts of the background image to display your window's background instead of being completely transparent and displaying the game UI display

-- this is the code that handles the background, note that the handles are assigned to the quickslot but they manipulate the icon
FoundWindow.FoundButton.Icon:SetBackground(0x4113f539) --0x4113f51a

FoundWindow.FoundButton.MouseEnter=function()
    FoundWindow.FoundButton.Icon:SetBackground(0x4113f4f7)
end
FoundWindow.FoundButton.MouseLeave=function()
	FoundWindow.FoundButton.Icon:SetBackground(0x4113f539)

end
FoundWindow.FoundButton.MouseDown=function()
	FoundWindow.FoundButton.Icon:SetBackground(0x4113f4f5)
	
	
end
FoundWindow.FoundButton.MouseUp=function()
	FoundWindow.FoundButton.Icon:SetBackground(0x4113f4f7)
end

FoundWindow.FoundButton.MouseClick=function()
	FoundWindow:SetVisible(false)
end



player.TargetChanged = function()
	if playing == true then
		local target = player:GetTarget()
		if target ~= nil then
			target=target:GetName()
			if currentPlayers[target] ~= nil then
				if currentPlayers[target]["Seeker"] == false  and currentPlayers[playerName]["Seeker"] == true then
					FoundWindow:SetVisible(true)
					local foundalias = "/"..chatNo.." <Select:IID:0x"..currentGameCode..">Found: <\\Select>".."<Select:IID:0x"..currentPlayers[target]["Code"] ..">"..target.."<\\Select>"

					FoundWindow.FoundButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,foundalias))
					FoundWindow.FoundButton.ShortcutData=foundalias; --save the alias text for later	


					--print(":)")	
				else
					FoundWindow:SetVisible(false)
				end
			else
				FoundWindow:SetVisible(false)
			end

		else
			FoundWindow:SetVisible(false)
		end

	end
end

playerName=player:GetName()
playerNo=""
for i = 1,16 do
	playerNo=playerNo..tostring(math.random(1,9))
end
--print(playerNo)
queueingPlayers={[playerName]={["Code"]=playerNo}}

Turbine.Shell.AddCommand("hns", dc);
chatNo=1
seed=Turbine.Engine.GetLocalTime()

countIn=60
-----------------------------------pwrchng



PwcWindow=Turbine.UI.Window()
PwcWindow:SetWantsUpdates(false)
--PwcWindow:SetZOrder(100)

PwcTitle=Turbine.UI.Label()

PwcTitle:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
PwcTitle:SetParent(PwcWindow)
PwcTitle:SetSize(500,100)
PwcTitle:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)

PwcText=Turbine.UI.Label()
--PwcText:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
PwcText:SetParent(PwcWindow)
PwcText:SetSize(100,100)
PwcText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
PwcText:SetPosition(Turbine.UI.Display:GetWidth()/2-60,Turbine.UI.Display:GetHeight()/2-290)
PwcText:SetText("Conceed Game:")


PwcWindow.FoundButton=Turbine.UI.Lotro.Quickslot();
PwcWindow.FoundButton:SetParent(PwcWindow);
PwcWindow.FoundButton:SetSize(26,22);

PwcWindow.FoundButton:SetPosition(Turbine.UI.Display:GetWidth()/2+40,Turbine.UI.Display:GetHeight()/2-250); --yeah, I got lazy and hardcoded the left side ;)
PwcWindow.FoundButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,""))
PwcWindow.FoundButton.ShortcutData=""; --save the alias text for later
PwcWindow.FoundButton:SetAllowDrop(false); -- turn off drag and drop so the user doesn't accidentally modify our button action
PwcWindow.FoundButton.DragDrop=function()
    -- even though we turned off drop operations, there is a bug that allows the quickslot to drop on itself effectively wiping out the shortcut
    local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"");
    sc:SetData(PwcWindow.FoundButton.ShortcutData);
    PwcWindow.FoundButton:SetShortcut(sc);
end

PwcWindow.FoundButton.Backdrop=Turbine.UI.Control(); -- note, if the icon has no transparencies then this backdrop is not needed
PwcWindow.FoundButton.Backdrop:SetParent(PwcWindow);
PwcWindow.FoundButton.Backdrop:SetSize(PwcWindow.FoundButton:GetSize());
PwcWindow.FoundButton.Backdrop:SetPosition(PwcWindow.FoundButton:GetPosition()); --yeah, I got lazy and hardcoded the left side ;)
PwcWindow.FoundButton.Backdrop:SetZOrder(PwcWindow.FoundButton:GetZOrder()+1); -- force the icon to be displayed above the quickslot
PwcWindow.FoundButton.Backdrop:SetBackColor(Turbine.UI.Color(1,0,0,0));
PwcWindow.FoundButton.Backdrop:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the quickslot behind it


PwcWindow.FoundButton.Icon=Turbine.UI.Control();
PwcWindow.FoundButton.Icon:SetParent(PwcWindow);
PwcWindow.FoundButton.Icon:SetSize(PwcWindow.FoundButton:GetSize());
PwcWindow.FoundButton.Icon:SetPosition(PwcWindow.FoundButton:GetPosition()); --yeah, I got lazy and hardcoded the left side ;)
PwcWindow.FoundButton.Icon:SetZOrder(PwcWindow.FoundButton:GetZOrder()+5); -- force the icon to be displayed above the quickslot
PwcWindow.FoundButton.Icon:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the quickslot behind it
PwcWindow.FoundButton.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay); -- this will cause any transparent parts of the background image to display your window's background instead of being completely transparent and displaying the game UI display

-- this is the code that handles the background, note that the handles are assigned to the quickslot but they manipulate the icon
PwcWindow.FoundButton.Icon:SetBackground(0x4110aed6) --0x4113f51a

PwcWindow.FoundButton.MouseEnter=function()
	local foundalias = "/"..chatNo.." <Select:IID:0x"..currentGameCode..">Quit: <\\Select>".."<Select:IID:0x"..currentPlayers[playerName]["Code"] ..">"..playerName.."<\\Select>"

	PwcWindow.FoundButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,foundalias))
	PwcWindow.FoundButton.ShortcutData=foundalias; --save the alias text for later	

	PwcWindow.FoundButton.Icon:SetBackground(0x4110aed7)
end
PwcWindow.FoundButton.MouseLeave=function()
	PwcWindow.FoundButton.Icon:SetBackground(0x4110aed6)

end
PwcWindow.FoundButton.MouseDown=function()
	PwcWindow.FoundButton.Icon:SetBackground(0x4110aed8)
	
	
end
PwcWindow.FoundButton.MouseUp=function()
	PwcWindow.FoundButton.Icon:SetBackground(0x4110aed7)
end

PwcWindow.FoundButton.MouseClick=function()
	PwcWindow:SetVisible(false)
	playing=nil
	currentPlayers=nil

end



player.PowerChanged=function()
	if playing ~= nil then
		if currentPlayers[playerName]["Seeker"]==false  then
			PwcWindow:SetWantsUpdates(false)
			PwcWindow:SetSize(Turbine.UI.Display:GetWidth(),Turbine.UI.Display:GetHeight())
			PwcWindow:SetPosition(0,0)
			PwcTitle:SetPosition(Turbine.UI.Display:GetWidth()/2-250,Turbine.UI.Display:GetHeight()/2-400)
			PwcWindow:SetBackColor(Turbine.UI.Color(1,0,0,0))
			PwcTitle:SetText("You have used a skill!")
			PwcWindow:SetVisible(true)
		end
	end
end

QuitGame=function()
	if playing ~= nil then

		PwcWindow:SetWantsUpdates(false)
		PwcWindow:SetSize(Turbine.UI.Display:GetWidth(),Turbine.UI.Display:GetHeight())
		PwcWindow:SetPosition(0,0)
		PwcTitle:SetPosition(Turbine.UI.Display:GetWidth()/2-250,Turbine.UI.Display:GetHeight()/2-400)
		PwcWindow:SetBackColor(Turbine.UI.Color(1,0,0,0))
		PwcTitle:SetText("You have decided to quit!")
		PwcWindow:SetVisible(true)

	end
end


QuitButton=Turbine.UI.Lotro.Button()
QuitButton:SetSize(100,30)
QuitButton:SetParent(ListWindow)
QuitButton:SetPosition(200,265)
QuitButton:SetText("Quit")
QuitButton.MouseClick=function()
	if playing ~= nil then
		local seekers= 0
		for i in pairs(currentPlayers) do
			if currentPlayers[i]["Seeker"]== true then
				seekers=seekers+1
			end
		end
		if seekers >1 or currentPlayers[playerName]["Seeker"]==false then
			QuitGame()
		else
			print("You Must Find Someone Else First")
		end
	end
end





-----------------------------------------------------Setting UP games---------------------------

MainWindow=Turbine.UI.Lotro.Window(); -- we call the constructor of the standard window object to create an instance
MainWindow:SetSize(400,250); -- sets the window size to 200 by 200 pixels
MainWindow:SetText("Hide and Seek"); -- sets the window size to 200 by 200 pixels
MainWindow:SetPosition(Turbine.UI.Display:GetWidth()/2-200,Turbine.UI.Display:GetHeight()/2-100); -- centers the window in the display
MainWindow.NoLabel=Turbine.UI.Label()
MainWindow.NoLabel:SetParent(MainWindow)
MainWindow.NoLabel:SetText("Chat Prefix:")
MainWindow.NoLabel:SetSize(100,30)
MainWindow.NoLabel:SetPosition(10,40)

MainWindow.ChatNumber=Turbine.UI.Lotro.TextBox()
MainWindow.ChatNumber:SetParent(MainWindow)
MainWindow.ChatNumber:SetText(tostring(chatNo))
MainWindow.ChatNumber:SetSize(40,30)
MainWindow.ChatNumber:SetPosition(110,30)
MainWindow.ChatNumber.TextChanged = function()
	chatNo=MainWindow.ChatNumber:GetText()
end

MainWindow.ShareLabel=Turbine.UI.Label()
MainWindow.ShareLabel:SetParent(MainWindow)
MainWindow.ShareLabel:SetText("Share Game:")
MainWindow.ShareLabel:SetSize(100,30)
MainWindow.ShareLabel:SetPosition(10,90)

----------------------------------------------------------------------------
MainWindow.New=Turbine.UI.Lotro.Button()
MainWindow.New:SetParent(MainWindow)
MainWindow.New:SetSize(170,22)
MainWindow.New:SetPosition(10,60)
MainWindow.New:SetText("Generate new game code")
MainWindow.New.MouseClick=function()
	currentGameCode=nil

	currentPlayers=nil
	playing=nil
	gameNo=""
	seed=Turbine.Engine.GetLocalTime()
	for i = 1,16 do
		gameNo=gameNo..tostring(math.random(1,9))
	end
	--print(gameNo)
	queueingPlayers={[playerName]={["Code"]=playerNo}}
	updateLists()
end


-----------------------------------------------------------------------------
MainWindow.ShareButton=Turbine.UI.Lotro.Quickslot();
MainWindow.ShareButton:SetParent(MainWindow);
MainWindow.ShareButton:SetSize(26,22);
gameNo=""
for i = 1,16 do
	gameNo=gameNo..tostring(math.random(1,9))
end
--gameNo=tostring(math.random(-1000000000000000,-9999999999999999))
--print(gameNo)
shareAlias="/1 ".."<Select:IID:0x"..gameNo..">Game: "..playerName.."<\\Select>"
MainWindow.ShareButton:SetPosition(110,90); --yeah, I got lazy and hardcoded the left side ;)
MainWindow.ShareButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,shareAlias))
MainWindow.ShareButton.ShortcutData=shareAlias; --save the alias text for later
MainWindow.ShareButton:SetAllowDrop(false); -- turn off drag and drop so the user doesn't accidentally modify our button action
MainWindow.ShareButton.DragDrop=function()
    -- even though we turned off drop operations, there is a bug that allows the quickslot to drop on itself effectively wiping out the shortcut
    local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"");
    sc:SetData(MainWindow.ShareButton.ShortcutData);
    MainWindow.ShareButton:SetShortcut(sc);
end
MainWindow.ShareButton.Backdrop=Turbine.UI.Control(); -- note, if the icon has no transparencies then this backdrop is not needed
MainWindow.ShareButton.Backdrop:SetParent(MainWindow);
MainWindow.ShareButton.Backdrop:SetSize(MainWindow.ShareButton:GetSize());
MainWindow.ShareButton.Backdrop:SetPosition(MainWindow.ShareButton:GetPosition()); --yeah, I got lazy and hardcoded the left side ;)
MainWindow.ShareButton.Backdrop:SetZOrder(MainWindow.ShareButton:GetZOrder()+1); -- force the icon to be displayed above the quickslot
MainWindow.ShareButton.Backdrop:SetBackColor(Turbine.UI.Color(1,0,0,0));
MainWindow.ShareButton.Backdrop:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the quickslot behind it
MainWindow.ShareButton.Icon=Turbine.UI.Control();
MainWindow.ShareButton.Icon:SetParent(MainWindow);
MainWindow.ShareButton.Icon:SetSize(MainWindow.ShareButton:GetSize());
MainWindow.ShareButton.Icon:SetPosition(MainWindow.ShareButton:GetPosition()); --yeah, I got lazy and hardcoded the left side ;)
MainWindow.ShareButton.Icon:SetZOrder(MainWindow.ShareButton:GetZOrder()+2); -- force the icon to be displayed above the quickslot
MainWindow.ShareButton.Icon:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the quickslot behind it
MainWindow.ShareButton.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay); -- this will cause any transparent parts of the background image to display your window's background instead of being completely transparent and displaying the game UI display

-- this is the code that handles the background, note that the handles are assigned to the quickslot but they manipulate the icon
MainWindow.ShareButton.Icon:SetBackground(0x4110aed6)
MainWindow.ShareButton.MouseEnter=function()
    MainWindow.ShareButton.Icon:SetBackground(0x4110aed7)
	shareAlias="/"..chatNo.." ".."<Select:IID:0x"..gameNo..">Game: "..playerName.."<\\Select>"
	MainWindow.ShareButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,shareAlias))
	MainWindow.ShareButton.ShortcutData=shareAlias; --save the alias text for later
	queueingPlayers[playerName]={["Code"]=playerNo}



end
MainWindow.ShareButton.MouseLeave=function()
	MainWindow.ShareButton.Icon:SetBackground(0x4110aed6)

end
MainWindow.ShareButton.MouseDown=function()
	MainWindow.ShareButton.Icon:SetBackground(0x4110aed8)
	
	
end
MainWindow.ShareButton.MouseUp=function()
	MainWindow.ShareButton.Icon:SetBackground(0x4110aed7)
end


MainWindow.ShareButton.MouseClick=function()
	currentPlayers=nil
	currentGameCode=nil
	playing=nil
	updateLists()
end

------------------------------------------------------------------
MainWindow.JoinLabel=Turbine.UI.Label()
MainWindow.JoinLabel:SetParent(MainWindow)
MainWindow.JoinLabel:SetText("Join Shared Game:")
MainWindow.JoinLabel:SetSize(100,30)
MainWindow.JoinLabel:SetPosition(10,120)

joinAlias=""
MainWindow.JoinButton=Turbine.UI.Lotro.Quickslot();
MainWindow.JoinButton:SetParent(MainWindow);
MainWindow.JoinButton:SetSize(26,22);

MainWindow.JoinButton:SetPosition(110,120); --yeah, I got lazy and hardcoded the left side ;)
MainWindow.JoinButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,joinAlias))
MainWindow.JoinButton.ShortcutData=joinAlias; --save the alias text for later
MainWindow.JoinButton:SetAllowDrop(false); -- turn off drag and drop so the user doesn't accidentally modify our button action
MainWindow.JoinButton.DragDrop=function()
    -- even though we turned off drop operations, there is a bug that allows the quickslot to drop on itself effectively wiping out the shortcut
    local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"");
    sc:SetData(MainWindow.JoinButton.ShortcutData);
    MainWindow.JoinButton:SetShortcut(sc);
end
MainWindow.JoinButton.Backdrop=Turbine.UI.Control(); -- note, if the icon has no transparencies then this backdrop is not needed
MainWindow.JoinButton.Backdrop:SetParent(MainWindow);
MainWindow.JoinButton.Backdrop:SetSize(MainWindow.JoinButton:GetSize());
MainWindow.JoinButton.Backdrop:SetPosition(MainWindow.JoinButton:GetPosition()); --yeah, I got lazy and hardcoded the left side ;)
MainWindow.JoinButton.Backdrop:SetZOrder(MainWindow.JoinButton:GetZOrder()+1); -- force the icon to be displayed above the quickslot
MainWindow.JoinButton.Backdrop:SetBackColor(Turbine.UI.Color(1,0,0,0));
MainWindow.JoinButton.Backdrop:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the quickslot behind it
MainWindow.JoinButton.Icon=Turbine.UI.Control();
MainWindow.JoinButton.Icon:SetParent(MainWindow);
MainWindow.JoinButton.Icon:SetSize(MainWindow.JoinButton:GetSize());
MainWindow.JoinButton.Icon:SetPosition(MainWindow.JoinButton:GetPosition()); --yeah, I got lazy and hardcoded the left side ;)
MainWindow.JoinButton.Icon:SetZOrder(MainWindow.JoinButton:GetZOrder()+2); -- force the icon to be displayed above the quickslot
MainWindow.JoinButton.Icon:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the quickslot behind it
MainWindow.JoinButton.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay); -- this will cause any transparent parts of the background image to display your window's background instead of being completely transparent and displaying the game UI display

-- this is the code that handles the background, note that the handles are assigned to the quickslot but they manipulate the icon
MainWindow.JoinButton.Icon:SetBackground(0x4110aed6)
MainWindow.JoinButton.MouseEnter=function()
    MainWindow.JoinButton.Icon:SetBackground(0x4110aed7)
	if recentlyShared ~= nil then
		--print(recentlyShared)
		joinAlias="/"..chatNo.." ".."<Select:IID:0x"..playerNo..">Join: "..string.match(recentlyShared,".+Game:%s(.+)<.+").."<\\Select><Select:IID:0x"..string.match(recentlyShared,".+<Select:IID:0x(.+)>Game%:.+")..">"
		MainWindow.JoinButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,joinAlias))
		MainWindow.JoinButton.ShortcutData=joinAlias; --save the alias text for later
	end

end
MainWindow.JoinButton.MouseLeave=function()
	MainWindow.JoinButton.Icon:SetBackground(0x4110aed6)

end
MainWindow.JoinButton.MouseDown=function()
	MainWindow.JoinButton.Icon:SetBackground(0x4110aed8)
	
	
end
MainWindow.JoinButton.MouseUp=function()
	MainWindow.JoinButton.Icon:SetBackground(0x4110aed7)
end

MainWindow.JoinButton.MouseClick=function()
	currentPlayers=nil
	playing=nil

	if recentlyShared ~= nil then
		--print(recentlyShared)

		currentGameCode=string.match(recentlyShared,".+<Select:IID:0x(.+)>Game%:.+")
		--print(">>>"..currentGameCode)
	end
end




-----------------------------------------------------
MainWindow.StartLabel=Turbine.UI.Label()
MainWindow.StartLabel:SetParent(MainWindow)
MainWindow.StartLabel:SetText("Start/Leave Other Game (Click Repeatedly):")
MainWindow.StartLabel:SetSize(100,60)
MainWindow.StartLabel:SetPosition(10,150)

startAlias=""
MainWindow.StartButton=Turbine.UI.Lotro.Quickslot();
MainWindow.StartButton:SetParent(MainWindow);
MainWindow.StartButton:SetSize(26,22);

MainWindow.StartButton:SetPosition(110,150); --yeah, I got lazy and hardcoded the left side ;)
MainWindow.StartButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,""))
MainWindow.StartButton.ShortcutData=""; --save the alias text for later
MainWindow.StartButton:SetAllowDrop(false); -- turn off drag and drop so the user doesn't accidentally modify our button action
MainWindow.StartButton.DragDrop=function()
    -- even though we turned off drop operations, there is a bug that allows the quickslot to drop on itself effectively wiping out the shortcut
    local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"");
    sc:SetData(MainWindow.StartButton.ShortcutData);
    MainWindow.StartButton:SetShortcut(sc);
end
MainWindow.StartButton.Backdrop=Turbine.UI.Control(); -- note, if the icon has no transparencies then this backdrop is not needed
MainWindow.StartButton.Backdrop:SetParent(MainWindow);
MainWindow.StartButton.Backdrop:SetSize(MainWindow.StartButton:GetSize());
MainWindow.StartButton.Backdrop:SetPosition(MainWindow.StartButton:GetPosition()); --yeah, I got lazy and hardcoded the left side ;)
MainWindow.StartButton.Backdrop:SetZOrder(MainWindow.StartButton:GetZOrder()+1); -- force the icon to be displayed above the quickslot
MainWindow.StartButton.Backdrop:SetBackColor(Turbine.UI.Color(1,0,0,0));
MainWindow.StartButton.Backdrop:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the quickslot behind it
MainWindow.StartButton.Icon=Turbine.UI.Control();
MainWindow.StartButton.Icon:SetParent(MainWindow);
MainWindow.StartButton.Icon:SetSize(MainWindow.StartButton:GetSize());
MainWindow.StartButton.Icon:SetPosition(MainWindow.StartButton:GetPosition()); --yeah, I got lazy and hardcoded the left side ;)
MainWindow.StartButton.Icon:SetZOrder(MainWindow.StartButton:GetZOrder()+2); -- force the icon to be displayed above the quickslot
MainWindow.StartButton.Icon:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the quickslot behind it
MainWindow.StartButton.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay); -- this will cause any transparent parts of the background image to display your window's background instead of being completely transparent and displaying the game UI display

-- this is the code that handles the background, note that the handles are assigned to the quickslot but they manipulate the icon
MainWindow.StartButton.Icon:SetBackground(0x4110aed6)
needsChange=true
MainWindow.StartButton.MouseEnter=function()
	--print("enter")
	

	if needsChange == true then
		--print("shit")
		needsChange=false
		MainWindow.StartButton.Icon:SetBackground(0x4110aed7)
		startAlias="/"..chatNo.." ".."<Select:IID:0x"..gameNo..">Start: "..playerName.."<\\Select>"
		--startAlias=startAlias.."<Select:IID:0x"..playerNo..">"..playerName.."<\\Select>"
		count=0
		for i in pairs(queueingPlayers) do
		count=count+1
		end
		--print(count)


		math.randomseed(seed)
		for i = 1,100 do
			seekerpos=math.random(count)
		end
		seekerpos=math.random(count)
		--print(seekerpos)
		count=1
		upTo=0
		for i in pairs(queueingPlayers) do
			if #(startAlias.."<Select:IID:0x"..queueingPlayers[i]["Code"]..">"..i..":s<\\Select>") < 381 then
				if count==seekerpos then
					queueingPlayers[i]["Seeker"]=true
					startAlias=startAlias.."<Select:IID:0x"..queueingPlayers[i]["Code"]..">"..i..":s<\\Select>"
				else
					queueingPlayers[i]["Seeker"]=false
					startAlias=startAlias.."<Select:IID:0x"..queueingPlayers[i]["Code"]..">"..i..":h<\\Select>"
				end
			else
				upTo=count
			end
	
			count=count+1
		end
		if upTo == 0 then
			startAlias=startAlias.."<rgb=0x000000></rgb>"
		end	
		MainWindow.StartButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,startAlias))
		MainWindow.StartButton.ShortcutData=startAlias; --save the alias text for later
		MainWindow.StartButton:SetWantsUpdates(false)

	end

end
MainWindow.StartButton.MouseLeave=function()
	MainWindow.StartButton.Icon:SetBackground(0x4110aed6)

end
MainWindow.StartButton.MouseDown=function()
	MainWindow.StartButton.Icon:SetBackground(0x4110aed8)
	
	
end
MainWindow.StartButton.MouseUp=function()
	MainWindow.StartButton.Icon:SetBackground(0x4110aed7)

end
MainWindow.StartButton.MouseClick=function()
	currentGameCode="nil"
	local count=0
	for i in pairs(queueingPlayers) do
		count=count+1
	end
	--print(upTo)
	if count >1 and upTo == 0 then
		print("Starting")
		startGame()
	end
	needsChange="later"
	tickDelay=10

	MainWindow.StartButton:SetWantsUpdates(true)
		
end
MainWindow.StartButton.Update=function()
	if upTo ~= 0 and upTo ~= nil and needsChange == "later" and tickDelay >= 1 then
		needsChange="intermidiate"
		--print(needsChange)
	elseif upTo ~= 0 and upTo ~= nil and needsChange == "intermidiate" and tickDelay < 1 then
		--print("working")
				needsChange=false
				startAlias="/"..chatNo.." ".."<Select:IID:0x"..gameNo..">Start: "..playerName.."<\\Select>"
			--startAlias=startAlias.."<Select:IID:0x"..playerNo..">"..playerName.."<\\Select>"
				local count=0
				for i in pairs(queueingPlayers) do
					count=count+1
				end
				--print(count)

				math.randomseed(seed)
				for i = 1,100 do
					seekerpos=math.random(count)
				end
				seekerpos=math.random(count)
				--print(seekerpos)
				count=1
				for i in pairs(queueingPlayers) do
					if #(startAlias.."<Select:IID:0x"..queueingPlayers[i]["Code"]..">"..i..":s<\\Select>") < 381 and count >= upTo then
						upTo = 0
						if count==seekerpos then
							queueingPlayers[i]["Seeker"]=true
							startAlias=startAlias.."<Select:IID:0x"..queueingPlayers[i]["Code"]..">"..i..":s<\\Select>"
						else
							queueingPlayers[i]["Seeker"]=false
							startAlias=startAlias.."<Select:IID:0x"..queueingPlayers[i]["Code"]..">"..i..":h<\\Select>"
						end
					else
						upTo=count
					end

					count=count+1
				end
				if upTo == 0 then
					startAlias=startAlias.."<rgb=0x000000></rgb>"
				end

				MainWindow.StartButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,startAlias))
				MainWindow.StartButton.ShortcutData=startAlias; --save the alias text for later
	elseif tickDelay < 1 then
		needsChange=true			

	end
	
	--print(tickDelay)
	if tickDelay < 1 then
		MainWindow.StartButton:SetWantsUpdates(false)
	end
	tickDelay=tickDelay-1
end
 -- initialize variable
 -- define the AddCallback function
 function AddCallback(object, event, callback)
   if (object[event] == nil) then
     object[event] = callback;
   else
     if (type(object[event]) == "table") then
       table.insert(object[event], callback);
     else
       object[event] = {object[event], callback};
     end
   end
   return callback;
 end
 MainWindow:SetVisible(false);
 ChatMonitor = Turbine.Chat;
 ChatReceived = function(f, args)
	local msg = args.Message;
	if string.find(msg,"<Select.+>Game%:.+") ~= nil then
		recentlyShared=msg
		--print(recentlyShared)
	elseif string.find(msg,"<Select.+>Join%:%s"..playerName..".+") ~= nil and string.find(msg,gameNo) ~= nil then
		local pc=string.match(msg,".+<Select.+0x(.+)>Join%:.+<\\Select")
		needsChange=true
		upTo=0
		--print(string.match(msg,"<Select.+>.+:%s(.+)<\\Select.+"))
		--print(pc)
		queueingPlayers[string.match(msg,"<Select.+>(.+)<\\Select>%:")]={["Code"]=pc}
		updateLists()
	elseif playing == nil then
		--print(CurrentGameCode)
		if currentGameCode == nil then
			currentGameCode="nil"
		end
		if string.find(msg,"<Select.+"..currentGameCode..">Start%:%s.+") ~= nil then

			queueingPlayers={}

			local s=string.gsub(msg,".-<.+Start:%s%a+<\\Select>","",1)
			while s ~= "" do
				local c,n,t=string.match(s,"<Select:IID:0x(%x+)>(%a+)%:(%a)<\\Select>")
				if c ~= nil and n~=nil and t~= nil then
					s=string.gsub(s,"<Select:IID:0x%x+>%a+%:%a<\\Select>","",1)
					queueingPlayers[n]={["Code"]=c,["Seeker"]=(t=="s")}
					--print(c)
					--print(n)
					--print(t)
					
				else
					s=""
				end
				--print(s)
			end
			if string.find(msg,"<rgb=0x000000></rgb>") ~= nil then
				startGame()
			end
		
		elseif string.find(msg,"<Select.+>Start%:%s.+") ~= nil and string.find(msg,"<Select:IID:0x"..gameNo) == nil  then
			local s=string.gsub(msg,".-<.+Start:%s%a+<\\Select>","",1)
			--print("other game")
			while s ~= "" do
				local c,n,t=string.match(s,"<Select:IID:0x(%x+)>(%a+)%:(%a)<\\Select>")
				if c ~= nil and n~=nil and t~= nil then
					s=string.gsub(s,"<Select:IID:0x%x+>%a+%:%a<\\Select>","",1)
					queueingPlayers[n]=nil
					updateLists()
					--print(c)
					--print(n)
					--print(t)
					
				else
					s=""
				end
				--print(s)
			end
		end

	elseif playing~= nil then
		--print(CurrentGameCode)
		if string.find(msg,"<Select.+"..currentGameCode..">Found%:%s.+") ~= nil then
			queueingPlayers={}

			local s=string.gsub(msg,".-<.+Found:%s%a+<\\Select>","",1)
			local c,n=string.match(s,"<Select:IID:0x(%x+)>(%a+)<\\Select>")
			local s=string.gsub(s,"<Select:IID:0x(%x+)>(%a+)<\\Select>%:","",1)

			local c,n=string.match(s,"<Select:IID:0x(%x+)>(%a+)<\\Select>")

					--print(c)
					--print(n)

			if c ~= nil and n~=nil  then
				if currentPlayers[n]["Code"] == c then
					currentPlayers[n]["Seeker"]=true
					local last=true
					for i in pairs(currentPlayers) do
						if currentPlayers[i]["Seeker"]==false then
							last = false
						end
					end
					if last then
						gameOver(n)
					else
						beenFound(n)
					end
					--print(c)
					--print(n)
					updateLists()
					
				end
				--print(s)
			end
		end

		if string.find(msg,"<Select.+"..currentGameCode..">Quit%:%s.+") ~= nil then
			queueingPlayers={}

			local s=string.gsub(msg,".-<.+Quit:%s%a+<\\Select>","",1)
			local c,n=string.match(s,"<Select:IID:0x(%x+)>(%a+)<\\Select>")
			local s=string.gsub(s,"<Select:IID:0x(%x+)>(%a+)<\\Select>%:","",1)

			local c,n=string.match(s,"<Select:IID:0x(%x+)>(%a+)<\\Select>")

					--print(c)
					--print(n)

			if c ~= nil and n~=nil  then
				if currentPlayers[n]["Code"] == c then
					currentPlayers[n]=nil
					local last=true
					for i in pairs(currentPlayers) do
						if currentPlayers[i]["Seeker"]==false then
							last = false
						end
					end
					if last then
						gameOver("No one")
					else
						beenQuit(n)
					end
					--print(c)
					--print(n)
					updateLists()
					
				end
				--print(s)
			end
		end



	end

	
    
  
 end
 AddCallback(Turbine.Chat, "Received", ChatReceived)
